SETS
t  Set of times        /t1*t24/
i  Set of nodes        /N1*N5/
g  Set of convetional generators /G1/
gd Set of distributed generators /GD1/
b  Set of batteries    /B1/
map(g,i)    Relates nodes and Conv. Gen. /G1.N1/
mapgd(gd,i) Relates nodes and Dist. Gen. /GD1.N3/
mapb(b,i)   Relates nodes and Batteries  /B1.N4/;
SCALAR
Sb Base of power [kW]   /100/
Dt Delta of time [h]    /1.0/;
ALIAS(i,j);
TABLE Gbus(i,j) Admittance matrix [p.u]
    N1   N2     N3     N4    N5
N1  450  -200   0     -250   0
N2 -200   1100 -400   -500   0
N3  0    -400   400    0     0
N4 -250  -500   0      1150 -400
N5  0     0     0     -400   400
TABLE Load(i,*) Demand information [p.u]
    PL
N1  0.00
N2  0.40
N3  0.00
N4  0.35
N5  0.50
TABLE CV(t,*) Cost [$\kW] and load variation [p.u]
      Cost   Var
t1    0.770  0.34
t2    0.710  0.22
t3    0.690  0.22
t4    0.700  0.18
t5    0.720  0.18
t6    0.800  0.22
t7    0.870  0.28
t8    0.910  0.40
t9    0.880  0.62
t10   0.910  0.72
t11   0.910  0.84
t12   0.910  0.90
t13   0.900  0.94
t14   0.895  0.90
t15   0.895  0.86
t16   0.900  0.90
t17   0.925  0.90
t18   0.945  0.86
t19   0.925  1.00
t20   0.905  0.92
t21   0.875  0.98
t22   0.825  0.90
t23   0.755  0.76
t24   0.685  0.58
TABLE Gend(t,gd)  Wind turbine generation [p.u]
       GD1
t1     0.491746506
t2     0.468282938
t3     0.452321598
t4     0.440593128
t5     0.442434522
t6     0.462949470
t7     0.542106738
t8     0.658875156
t9     0.732416360
t10    0.778458598
t11    0.767274808
t12    0.745063928
t13    0.733924020
t14    0.734122492
t15    0.730361338
t16    0.726223540
t17    0.694916588
t18    0.646582836
t19    0.544928278
t20    0.499666060
t21    0.469398008
t22    0.406462266
t23    0.319635270
t24    0.284079772
;
TABLE Batt(b,*) Battery operation rank
      SoCmin  SoCmax  SoCi SoCf Phi   PbD      PbC
*     [%]     [%]     [%]  [%] [p.u] [p.u]    [p.u]
B1    0.0     1       0.0  0.0  0.8   0.3125  -0.25;
Variables
z Objective function variable
v(i,t)    Nodal voltage [p.u]
p(g,t)    Conventional power generation [p.u]
pgd(gd,t) Distributed power generation [p.u]
SoC(b,t)  State-of-Charge of the battery
pb(b,t)   Power input\output in the battery [p.u];
pgd.lo(gd,t) = 0;               pgd.up(gd,t) = Gend(t,gd);
pb.lo(b,t) = Batt(b,'PbC');     pb.up(b,t) =   Batt(b,'PbD');
SoC.lo(b,t) = Batt(b,'SoCmin'); SoC.up(b,t) =  Batt(b,'SoCmax');
SoC.fx(b,'t1') =  Batt(b,'SoCi'); SoC.fx(b,'t24') = Batt(b,'SoCf');
v.lo(i,t) = 0.95; v.up(i,t) = 1.05;
v.fx('N1',t) = 1.0; p.lo(g,t) = 0;
Equations
Fo  Objetive function equaation
Balance(i,t) Power balance
States(b,t) State of the battery;
Fo.. z =e= Sb*sum(g,sum(t,CV(t,'Cost')*p(g,t)))*Dt;
Balance(i,t).. sum(g$map(g,i),p(g,t)) + sum(gd$mapgd(gd,i),pgd(gd,t))+ sum(b$mapb(b,i),pb(b,t)) - Load(i,'PL')*(CV(t,'Var'))*(v(i,t)**2)
               =e= sum(j,Gbus(i,j)*v(i,t)*v(j,t));
States(b,t)..  SoC(b,t) =e= SoC(b,t-1)$(ord(t) gt 1) + Batt(b,'SoCini')$(ord(t) eq 1) - Batt(b,'Phi')*Pb(b,t);
Model   Eco_Disp_Batts /all/;
solve   Eco_Disp_Batts using NLP minimizing z;
display z.l;
